
/* Border */
@mixin border($top,$right,$bottom,$left,$color,$type) {
	@if $top == 0 {}
	@else{
		border-top: $top $type $color;
	}
	@if $right == 0 {}
	@else{
		border-right: $right $type $color;
	}
	@if $bottom == 0 {}
	@else{
		border-bottom: $bottom $type $color;
	}
	@if $left == 0 {}
	@else{
		border-left: $left $type $color;
	}
}

//=========================================================================

/* border-radius */
@mixin border-radius($radius) {
  -webkit-border-radius: $radius;
     -moz-border-radius: $radius;
      -ms-border-radius: $radius;
          border-radius: $radius;
}

//=========================================================================

/* aceaceholder */
@mixin placeholder {
  &:-webkit-input-placeholder  {@content}
  &:-moz-placeholder           {@content}
  &::-moz-placeholder          {@content}
  &:-ms-input-placeholder      {@content}  
}


//=========================================================================

/* Anchor Links */
@mixin linx ($link, $hover: $link, $visit: $link, $active: $link, $hover-dec: none) {
  color: $link;
  text-decoration: $hover-dec;
  &:focus, &:hover {
    color: $hover;
    text-decoration: $hover-dec;
  }
  &:visited {
    color: $visit;
  }
  &:active {
    color: $active;
  }
}

//=========================================================================

/* Box Sizing */
@mixin box-sizing($box-model) {
  -webkit-box-sizing: $box-model; // Safari <= 5
     -moz-box-sizing: $box-model; // Firefox <= 19
          box-sizing: $box-model;
}

//=========================================================================

/* box-shadow */
@mixin box-shadow($box-shadow) {
  -webkit-box-shadow: $box-shadow ;
          box-shadow: $box-shadow;
}

//=========================================================================

@mixin text-shadow($text-shadow) {
  -webkit-text-shadow: $text-shadow ;
          text-shadow: $text-shadow;
}

//=========================================================================

/* breakpoints */

@mixin breakpoint($point) {
  @if $point == superlarge {
    @media (max-width: 1680px) { @content; } /* 1680 px*/
  }
  @if $point == xxlarge {
    @media (max-width: 1600px) { @content; } /* 1600 px*/
  }
  @if $point == xlarge {
    @media (max-width: 1199px) { @content; } /* 1199 px*/
  }
  @if $point == large {
    @media (max-width: 1024px) { @content; } /* 1024 px*/
  }
  @else if $point == medium {
    @media (max-width: 991px) { @content; } /* 991 px*/
  }
  @else if $point == small {
    @media (max-width: 767px)  { @content; } /* 767 px*/
  }
  @else if $point == x-small {
    @media (max-width: 480px)  { @content; } /* 480 px*/
  }
}

//=========================================================================

/* Retina */
@mixin image-2x($image, $width, $height) {
  @media (min--moz-device-pixel-ratio: 1.3),
         (-o-min-device-pixel-ratio: 2.6/2),
         (-webkit-min-device-pixel-ratio: 1.3),
         (min-device-pixel-ratio: 1.3),
         (min-resolution: 1.3dppx) {                             
            background-image: url($image);                /* on retina, use image that's scaled by 2 */
            background-size: $width $height;        /*@include image-2x("url", 100%, auto);*/
         
          }
}

//=========================================================================

/* transition */

@mixin transition($transition...) {
  -webkit-transition: $transition;
     -moz-transition: $transition;
       -o-transition: $transition;
          transition: $transition;
}
@mixin transition-property($property...) {
  -webkit-transition-property: $property;
     -moz-transition-property: $property;
       -o-transition-property: $property;
          transition-property: $property;
}
@mixin transition-duration($duration...) {
  -webkit-transition-property: $duration;
     -moz-transition-property: $duration;
       -o-transition-property: $duration;
          transition-property: $duration;
}
@mixin transition-timing-function($timing...) {
  -webkit-transition-timing-function: $timing;
     -moz-transition-timing-function: $timing;
       -o-transition-timing-function: $timing;
          transition-timing-function: $timing;
}
@mixin transition-delay($delay...) {
  -webkit-transition-delay: $delay;
     -moz-transition-delay: $delay;
       -o-transition-delay: $delay;
          transition-delay: $delay;
}


/* ===== transformation ===== */

@mixin transform($transforms) {
     -moz-transform: $transforms;
       -o-transform: $transforms;
      -ms-transform: $transforms;
  -webkit-transform: $transforms;
          transform: $transforms !important;
}

/* rotate */
@mixin rotate ($deg) {
  @include transform(rotate(#{$deg}deg));
}
 
/* scale */
@mixin scale($scale) {
  @include transform(scale($scale));
} 
/* translate */
@mixin translate ($x, $y) {
  @include transform(translate($x, $y));
}
@mixin translate ($x) {
  @include transform(translateX($x));
}
@mixin translate ($y) {
  @include transform(translateY($y));
}
/* skew */
@mixin skew ($x, $y) {
  @include transform(skew(#{$x}deg, #{$y}deg));
}
/* transform origin */
@mixin transform-origin ($origin) {
      moz-transform-origin: $origin;
       -o-transform-origin: $origin;
      -ms-transform-origin: $origin;
  -webkit-transform-origin: $origin;
          transform-origin: $origin;
}

/* ===== transformation Ends ===== */


/* ===== Linear Gradients ===== */

@mixin linearGradient($top, $bottom){
    background: $top; /* Old browsers */
    background: -moz-linear-gradient(top,  $top 0%, $bottom 100%); /* FF3.6+ */
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,$top), color-stop(100%,$bottom)); /* Chrome,Safari4+ */
    background: -webkit-linear-gradient(top,  $top 0%,$bottom 100%); /* Chrome10+,Safari5.1+ */
    background: -o-linear-gradient(top,  $top 0%,$bottom 100%); /* Opera 11.10+ */
    background: -ms-linear-gradient(top,  $top 0%,$bottom 100%); /* IE10+ */
    background: linear-gradient(to bottom,  $top 0%,$bottom 100%); /* W3C */
    filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ffffff', endColorstr='#000000',GradientType=0 ); /* IE6-9 */
}

/* ===== Linear Gradients Ends ===== */


/* ====== Absolute Centering ====== */

@mixin absolutecenter($axis: "both"){
  // @include absolutecenter(both);

  position:absolute;

  @if $axis == "y"{
    top: 50%;
    @include transform(translateY(-50%));
  }
  @if $axis == "x"{
    left: 50%;
    transform: translateX(-50%);
  }
  @if $axis == "both"{
    top:50%;
    left:50%;
    transform: translate(-50%,-50%);
  }
}
/* ==== Absolute Centering Ends ==== */

/* ====== Triangles ====== */
@mixin triangle($direction, $size: 0.375rem, $color: #222){
  content: '';
  display: block;
  position: absolute;
  height: 0; width: 0;
  @if ($direction == 'up'){
    border-bottom: $size solid $color;
    border-left: $size solid transparent;
    border-right: $size solid transparent;
  }
  @else if ($direction == 'down'){
    border-top: $size solid $color;
    border-left: $size solid transparent;
    border-right: $size solid transparent;
  }
  @else if ($direction == 'left'){
    border-top: $size solid transparent;
    border-bottom: $size solid transparent;
    border-right: $size solid $color;
  }
  @else if ($direction == 'right'){
    border-top: $size solid transparent;
    border-bottom: $size solid transparent;
    border-left: $size solid $color;
  }
}
/* ====== Triangles Ends ====== */
